import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkCard, ThinkCardParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询
 */
export async function pageThinkCard(params: ThinkCardParam) {
  const res = await request.get<ApiResult<PageResult<ThinkCard>>>(
    THINK_API_URL + '/think/think-card/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询列表
 */
export async function listThinkCard(params?: ThinkCardParam) {
  const res = await request.get<ApiResult<ThinkCard[]>>(
    THINK_API_URL + '/think/think-card',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加
 */
export async function addThinkCard(data: ThinkCard) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-card',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改
 */
export async function updateThinkCard(data: ThinkCard) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-card',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除
 */
export async function removeThinkCard(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-card/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除
 */
export async function removeBatchThinkCard(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-card/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询
 */
export async function getThinkCard(id: number) {
  const res = await request.get<ApiResult<ThinkCard>>(
    THINK_API_URL + '/think/think-card/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
